#include "FiveWin.ch"
#include "gif.ch"

STATIC hResources, oDlg, oDlg1, c_path, c_path1, lRun := .F., nBrush := 3, oMeter
STATIC oTextFont1, oTextFont2, oABtn[1], oSBtn[7], oImage, cTyp := "A_", nRecords := 1, nRecPos := 1
STATIC nStep := 5, nDelay := 100, nFrames := 20, nFCount := 1

FUNCTION MAIN()
LOCAL oTextFont, oRad, nTyp := 1, oSay[3], oLbx1, oLbx2, cDelay := "100", cStep := "5"  

c_path	:= cFilePath(GetModuleFileName( GetInstance() ) )
c_path1	:= c_Path + "IMAGES\"
SetBalloon( .T. ) // Balloon shape required for tooltips

REQUEST DBFCDX
RDDSETDEFAULT ( "DBFCDX" )

NET_USE (c_Path + "CUST.dbf", "CUST", 3,.T.) 
DBSELECTAREA("CUST")
ORDCREATE( ,"CUST1","LAST", {|| LAST } , .F. )
("CUST")->(DBSETORDER(1))
nRecords := RECCOUNT()
DBGOTOP()

DEFINE FONT oTextFont1 NAME "Arial" SIZE 0, -14
DEFINE FONT oTextFont2 NAME "Arial" SIZE 0, -18 BOLD

// oTextFont := TFont():New( "Arial", 0, 12,.F.,.F.,  0,  0,  0,.F.,.F.)
hResources := GetResources()
SET RESOURCES TO c_path1 + "ANIBTN.dll"

DEFINE DIALOG oDlg ;
FROM  0, 0 TO 460, 440 PIXEL TITLE "INDEX-builder Release 3.1"  ICON "FAVORITE"   

@ 10, 60 IMAGE oImage RESOURCE "C_30"  OF oDlg ; // start-frame
SIZE 80, 80 PIXEL  NOBORDER
oImage:cTooltip := "Image"
oImage:lTransparent := .T.

@ 90, 50 BTNBMP oABtn[1] SIZE 80, 25 OF oDlg  2007 ;
FILENAME c_path1 + "Index.bmp" ;
LEFT BORDER ;
PROMPT "&Build Index" ;
FONT oTextFont2 ;
ACTION ( 	lRun := .T., MAKE_INDEX( oMeter, @nRecPos, oImage ), ;   
                oMeter:Set( 0 ) ) 
//RUN_ACT(cTyp, oImage) )
oABtn[1]:lTransparent := .T.
oABtn[1]:cTooltip :=  { "Run" + CRLF + ;
                                 "Image-animation","RUN", 1, CLR_BLACK, 14089979 }

@ 10, 140 SAY oSay[1] PROMPT "Delay" FONT oTextFont1 COLOR 0 PIXEL
oSay[1]:lTransparent := .T.

@ 10, 160 LISTBOX oLbx1 VAR cDelay SIZE 40, 40 PIXEL ;
ITEMS   { "1", "50", "100", "150", "200" } FONT oTextFont2 ;
BITMAPS { c_path1 + "Col_1.bmp", c_path1 + "Col_2.bmp", c_path1 + "Col_3.bmp", ;
                 c_path1 + "Col_4.bmp", c_path1 + "Col_5.bmp" } ;
ON CHANGE nDelay := VAL(cDelay)  

@ 60, 140 SAY oSay[2] PROMPT "Steps" FONT oTextFont1 COLOR 0 PIXEL
oSay[2]:lTransparent := .T.

@ 60, 160 LISTBOX oLbx2 VAR cStep SIZE 40, 40 PIXEL ;
ITEMS   { "1", "10", "20", "30", "40" } FONT oTextFont2 ;
BITMAPS { c_path1 + "Col_1.bmp", c_path1 + "Col_2.bmp", c_path1 + "Col_3.bmp", ;
                 c_path1 + "Col_4.bmp", c_path1 + "Col_5.bmp" } ;
ON CHANGE ( nStep := VAL(cStep) )  

@ 110, 155 RADIO oRad3 VAR nTyp OF oDlg PIXEL ;
ITEMS "Typ &1", "Typ &2", "Typ &3" _3D SIZE 50, 10 ;
HELPID 100, 101, 102 ;
ON CHANGE ( IIF( nTyp = 1, ( cTyp := "A_", nFrames := 20 ), NIL ), ;
			IIF( nTyp = 2, ( cTyp := "B_", nFrames := 18 ), NIL ), ;
			IIF( nTyp = 3, ( cTyp := "C_", nFrames := 12 ), NIL ) )
AEval( oRad3:aItems, { | oRad | oRad:lTransparent := .T., ;
					      oRad:SetFont ( oTextFont2 ), ;
                                              oRad:nClrText := 0 } )

@ 140, 10 SAY oSay[3] PROMPT "Building Index ...." FONT oTextFont1 COLOR 0 PIXEL
oSay[3]:lTransparent := .T.

@ 150, 10 METEREX oMeter VAR nRecPos SIZE 200, 12 TOTAL nRecords ROUND ROUNDSIZE 6 OF oDlg PIXEL  
//GRADIENT CHUNK { { 1/2, 16443068, 15775859 }, { 1/2, 15775859, 16443068 } }; // Defined Red / Green
//GRADIENT TRACK { { 1/2, 16443068, 255 }, { 1/2, 255, 16443068 } } // Start with 100 % red

oMeter:aGrad := { { 1/2, 16443068, 15775859 }, { 1/2, 15775859, 16443068 } } 
oMeter:aGradMet := { { 1/2, 16443068, 255 }, { 1/2, 255, 16443068 } }
 

// -----------------------

@ 170, 10 BTNBMP oSBtn[1] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Color.bmp" ;
LEFT ;
PROMPT "&Color" ;
FONT oTextFont1 ;
ACTION ( nBrush := 1, DRAW_BACK( oDlg, 1, 16762767 ) )
oSBtn[1]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[1]:nLayout := 2
oSBtn[1]:SetColor( 128 )
oSBtn[1]:cTooltip :=  { "use color" + CRLF + ;
                               "Background","COLOR", 1, CLR_BLACK, 16762767 }

@ 170, 80 BTNBMP oSBtn[2] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Gradient.bmp" ;
LEFT ;
PROMPT "&Gradient" ;
FONT oTextFont1 ;
ACTION ( nBrush := 2, DRAW_BACK( oDlg, 2, 16762767, 16773088, .T., 0.2 ) ) 
oSBtn[2]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[2]:nLayout := 2
oSBtn[2]:SetColor( 128 )
oSBtn[2]:cTooltip :=  { "use Gradient" + CRLF + ;
                               "Background","GRADIENT", 1, CLR_BLACK, 14089979 }

@ 170, 150 BTNBMP oSBtn[3] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Brush1.bmp" ;
LEFT ;
PROMPT "&Brush" ;
FONT oTextFont1 ;
ACTION ( nBrush := 3, DRAW_BACK( oDlg, 3, , , , , "Marble.bmp" ) )
oSBtn[3]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[3]:nLayout := 2
oSBtn[3]:SetColor( 128 )
oSBtn[3]:cTooltip :=  { "use Brush" + CRLF + ;
                               "Background","BRUSH", 1, CLR_BLACK, 14089979 }

@ 200, 10 BTNBMP oSBtn[4] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Image.bmp" ;
LEFT ;
PROMPT "&Image" ;
FONT oTextFont1 ;
ACTION ( nBrush := 4, DRAW_BACK( oDlg, 4, , , , , ,"Picture.jpg" ) ) 
oSBtn[4]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[4]:nLayout := 2
oSBtn[4]:SetColor( 128 )
oSBtn[4]:cTooltip :=  { "use Image" + CRLF + ;
                               "Background","IMAGE", 1, CLR_BLACK, 14089979 }

@ 200, 80 BTNBMP oSBtn[5] SIZE 60, 20 OF oDlg  2007 ;
FILENAME c_path1 + "Stop.bmp" ;
LEFT ;
PROMPT "&STOP ani." ;
FONT oTextFont1 ;
ACTION lRun := .F.  
oSBtn[5]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 16765863, 16777215 }, ;
	  { 0.5, 16777215, 16765863 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[5]:nLayout := 2
oSBtn[5]:SetColor( 128 )
oSBtn[5]:cTooltip :=  { "STOP" + CRLF + ;
                                "animation","STOP", 1, CLR_BLACK, 14089979 }

@ 200, 150 BTNBMP oSBtn[6] SIZE 60, 20 OF oDlg  2007 ;
FILENAME  c_path1 + "Exit.bmp" ;
LEFT ;
PROMPT "&Exit" ;
FONT oTextFont1 ;
ACTION oDlg:End() 
oSBtn[6]:bClrGrad = { | lMouseOver | If( ! lMouseOver,; 
	{ { 0.5, 10526975, 16777215 }, ;
	  { 0.5, 16777215, 10526975 } }, ;
	{ { 0.5, 16768185, 16777215 }, ;
	   { 0.5, 16777215, 16768185  } } ) }
oSBtn[6]:nLayout := 2
oSBtn[6]:SetColor( 128 )
oSBtn[6]:cTooltip :=  { "Exit" + CRLF + ;
                                "Animation-Test","EXIT", 1, CLR_BLACK, 14089979 }

ACTIVATE DIALOG oDlg CENTERED ;
ON INIT DRAW_BACK( oDlg, 3, , , , , "Marble.bmp" , "Picture.jpg" )
 
SET RESOURCES TO

oTextFont1:End()
oTextFont2:End()

RETURN NIL

// --------  BACKGROUND ---------------

FUNCTION DRAW_BACK( oWnd, nStyle, nColor1, nColor2, lDirect, nMove, cBrush, cImage ) 
LOCAL hDC, oBrush, oImage, aGrad, I := 1
LOCAL aRect := GETCLIENTRECT( oWnd:hWnd ) 

IF nStyle = 1 // COLOR
	DEFINE BRUSH oBrush COLOR nColor1
ENDIF
IF nStyle = 2 // GRADIENT
	DEFINE BRUSH oBrush GRADIENT { { nMove, nColor1, nColor2 }, { nMove, nColor2, nColor1 } }
ENDIF
IF nStyle = 3 // BMP-BRUSH
	IF FILE( c_path1 + cBrush ) 
		DEFINE BRUSH oBrush FILE c_path1 + cBrush
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File : " + cBrush + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nStyle = 4 // Image ADJUSTED
	IF FILE( c_path1 + cImage ) 
		DEFINE IMAGE oImage FILE c_path1 + cImage
		oBrush := TBrush():new( ,,,, ResizeBmp( oImage:hBitmap, aRect[4], aRect[3], .T. ) ) 
		oImage:End()
	ELSE
		IF !EMPTY(cImage)
			MsgAlert( "File  : " + cImage + CRLF + ;
					"does not exist" + CRLF + ; 
				        "to create Background !", "ATTENTION" ) 
		ENDIF
	ENDIF
ENDIF
IF nBrush = 1
	oABtn[1]:SetColor( 255 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 2
	oABtn[1]:SetColor( 0 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 3
	oABtn[1]:SetColor( 255 )
	oABtn[1]:Refresh()
ELSEIF nBrush = 4
	oABtn[1]:SetColor( 65535 )
	oABtn[1]:Refresh()
ENDIF

oWnd:Setbrush( oBrush )
//oBrush:End()

RETURN( NIL)

// --------------------------

FUNCTION MAKE_INDEX( oMeter, nRecPos, oImage )
LOCAL nColor := 255
nFCount := 1

DBSELECTAREA("CUST")
DBGOTOP()
IF NET_FLOCK ( 3 )

	ORDCONDSET( ;								// <cForCondition>
				, ;								// <bForCondition>
				, .T. ;							// <lAll>
				, { || lRun = .T. } ;					// <bWhileCondition> break if lRun = .F.
				, { || nRecPos += nStep, ;				// <bEval>
					SET_ANI( oImage, @nRecPos, oMeter ), ;	// animation
					oMeter:Set( nRecPos ), ;			// position>
					SysRefresh() } ;					// refresh
				       , nStep;						// nInterval
				       , 1 ;							// <nStart ( first record )>
				       , , ,.F., .F., .F. ;					// <nRecords, nRecord, lRest, lDescend, lAdditive>
				       , .T., .F., .F. ) 					// <lCurrent>, <lCustom>, <lNoOptimize>
	ORDCREATE( ,"CUST1",	 "LAST", {|| LAST }, .F. )

	nRecPos = oMeter:nTotal
	oMeter:Set( nRecPos )

	oImage:SetBMP( "C_30" )	// start-image

	NET_ULOCK()

ENDIF

RETURN NIL   

//------------------ ANIMATION -----------

FUNCTION SET_ANI( oImage, nRecPos, oMeter )
LOCAL nSplit := nRecords / 3.33

// nRecords := RECCOUNT()
// MsgAlert( nRecpos ) // recordposition

IF nFCount > nFrames
	nFCount := 1 								// if max, set animation to 1
ENDIF

IF cTyp <> "B_"									// normal style
	oImage:SetBMP( cTyp + LTRIM(STR(nFCount)) )	 
ELSEIF cTyp = "B_" .and. nRecpos <= nSplit			// different colors after 33.3 % and 66.9 %
	oImage:SetBMP( "E_" + LTRIM(STR(nFCount)) )
ELSEIF cTyp = "B_" .and. nRecpos > nSplit  .and. nRecpos < nSplit * 2
	oImage:SetBMP( "D_" + LTRIM(STR(nFCount)) )
ELSEIF cTyp = "B_" .and. nRecpos > nSplit * 2
	oImage:SetBMP( "B_" + LTRIM(STR(nFCount)) )
ENDIF
Sleep( nDelay )									// added to slow down !!!
nFCount++

//IF nRecpos < nSplit
//	oMeter:aGradMet := { { 1/2, 16443068, 255 }, { 1/2, 255, 16443068 } } 
//ENDIF
//IF nRecpos > nSplit  .and. nRecpos < nSplit * 2
//	oMeter:aGradMet := { { 1/2, 16443068, 1398178 }, { 1/2, 1398178, 16443068 } } 
//ENDIF
//IF nRecpos > nSplit * 2
//	oMeter:aGradMet := { { 1/2, 16443068, 3261952 }, { 1/2, 3261952, 16443068 } } 
//ENDIF

RETURN NIL

// ---------- NET - FUNCTIONS ----------------------------
// --------------------------------------------------------------------

FUNCTION NET_USE ( cDBName, cAlias, nTrials, lNet )
LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTrcount   := nTrials
YesNo := .F.

// SHARED    all Users
// EXCLUSIVE  1 User

IF File( cDBName )
	nTrials := nTrcount
	DO WHILE !lOpen
		DO WHILE .T.
			IF !lNet
				USE &cDBName ALIAS &cAlias NEW EXCLUSIVE
			ELSE
				USE &cDBName ALIAS &cAlias NEW SHARED
			ENDIF
			IF !NetErr()
				lReturn   := .T.
				lOpen     := .T.
				nTrials := 0
			ELSE
				IF lNet = .T.
					Status := "SHARED"
				ELSE
					Status := "EXCLUSIVE"
				ENDIF
				IF nTrcount = nTrials
					xName := WNetGetUser()
					IF MsgYesNo( "Open " + Status + "  of " + upper(cDBName) + " not possible !" + ;
			                                       " try again ?", "Network-error -> &xName !" )
						nTrials := nTrcount
						YesNo := .T.
					ELSE
						nTrials := 0
						YesNo := .F.
					ENDIF
				ENDIF
				IF YesNo = .T.
					nTrials --
					IF nTrials > 0 .AND. nTime > 0
						NET_WAIT ( nTrcount, nTrials, nTime)
					ENDIF
					IF nTrials = 0
						nTrials := nTrcount
					ENDIF
				ELSE
					lReturn   := .F.
					lOpen     := .T.
					nTrials := 0
				ENDIF
			ENDIF
			IF nTrials = 0
				lOpen := .T.
				EXIT
			ENDIF
		ENDDO
	ENDDO
ELSE
	nMsgBox ("File -> " + cDBName + " is missing !", "Attention !")
	SET RESOURCES to
	set _3DLOOK OFF
	FreeLibrary()
	Close database
	QUIT
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_CLOSE( nTrials, nTime )

LOCAL lReturn  := .T.
LOCAL lOpen    := .F.

nTtrcount   := nTrials
YesNo    := .F.

cDBName := DBF()

DO WHILE !lOpen
	DO WHILE nTrials > 0
		USE
		IF NetErr()
			nTrials --
			IF MsgYesNo( "Close of file : " + upper(cDBName) + " not possible !" + ;
				" Try again ?", "Network-Error !" )
				lOpen :=.T.
				nTrials := ntrcount
				IF nTrials > 0 .AND. nTime > 0
					NET_WAIT ( nTrcount, nTrials, nTime)
				ENDIF
			ELSE
				lReturn   := .F.
				lOpen     := .T.
				nTrials := 0
			ENDIF
		ELSE
			lReturn   := .T.
			lOpen     := .T.
			nTrials := 0
		ENDIF
	ENDDO
ENDDO

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_RLOCK( nTrials, nTime )
LOCAL   lReturn   := .F.
LOCAL   nTrcount   := 0
LOCAL   nZSek     := 0
nTrcount := nTrials

DO WHILE !lReturn
	DO WHILE nTrials > 0
		IF !RLock()
			nTrials --
			IF nTrials > 0 .AND. nTime > 0
				NET_WAIT ( nTrcount, nTrials, nTime )
			ENDIF
		ELSE
			lReturn := .T.
			EXIT
		ENDIF
	ENDDO
	IF nTrials = 0
		IF MsgYesNo( "Not possible, to lock the record !" + ;
				       " Try again ?", "Network Error !" )
			nTrials := nTrcount
		ELSE
			lReturn := .F.
			EXIT
		ENDIF
	ENDIF
ENDDO
IF lReturn = .F.
	nMsgBox ("Files are not saved !!!", "Attention !")
ENDIF

RETURN lReturn

//-------------------------------------------------------

FUNCTION NET_ULOCK()

LOCAL   lReturn   := .F.

IF len(Fieldname(1)) > 0                     
	UNLOCK                                      
ENDIF

RETURN lReturn

// -----------------------

FUNCTION NET_FLOCK ( nTrials )
LOCAL lReturn   := .F., nTrCount := nTrials

DO WHILE nTrcount <= nTrials
	IF !FLock()
		nTrials --
		IF nTrials > 0 
			NET_WAIT ( nTrials )
		ENDIF
	ELSE
		lReturn := .T.
		EXIT
	ENDIF
	IF nTrials = 0
		IF MsgYesNo( "File-lock of " + upper(cDBName) + " not possible !" + ;
                             "Try again ?", "Network Error !" )
			nTrials := nTrcount
		ELSE
			lReturn := .F.
			nTrials := nTrcount
			EXIT
		ENDIF
	ENDIF
ENDDO

IF lReturn = .F.
	nMsgBox ("Not possible to look " + upper(cDBName) + "  !!!", "Attention !")
ENDIF

RETURN lReturn

// ----------------------

FUNCTION NET_WAIT ( nTrcount, nTrials, nTime )

local oMeter, oText1

MsgMeter( { | oMeter, oText1 | ;
SHOW_WAIT(nTrcount, nTrials, nTime, oMeter, oText1) } , ;
"rest trials : " + LTRIM(STR(nTrials)) + ". trial..." )

RETURN nil

// ----------------------

STATIC FUNCTION SHOW_WAIT( nTrcount, nTrials, nTime, oMeter, oText1 )

oMeter:nTotal = nTrcount
nZSek := Seconds()
oText1:SetText( "rest of trials : " + ltrim(str(nTrials)))
oMeter:Set( nTrials )
SysRefresh()
DO WHILE Seconds() < nZSek + nTime
ENDDO

RETURN nil

// -----------

DLL32 FUNCTION BWCCRegister( hInst AS LONG ) AS WORD PASCAL LIB "Anibtn.DLL"


/*

Function Animate(cResource) 

local oDlg,lOk 

DEFINE DIALOG oDlg FROM 10, 20 TO 18, 65 TITLE "Testing Animation" 

@ 3.5, 2 BUTTON "&Ok" OF oDlg SIZE 35, 12 ACTION ( oDlg:End, lOk := .t. ) DEFAULT 

ACTIVATE DIALOG oDlg CENTERED ON INIT Startup(oDlg,cResource) 

return nil 


Function Startup(oDlg,cResource) 

local oTmr,oBmp,nFrames,nFrameWidth 

@ 2, 20 BITMAP oBmp RESOURCE cResource SIZE 0,0 PIXEL OF oDlg NOBORDER 

oBmp:SetColor(GetSysColor( COLOR_BTNFACE ),GetSysColor( COLOR_BTNFACE )) 

nFrames := val(right(cResource,2)) 

nFrameWidth := oBmp:nWidth()/nFrames 

oBmp:lTransparent = .t. 

MoveWindow(oBmp:hWnd,2,20,nFrameWidth,oBmp:nHeight()) 

DEFINE TIMER oTmr OF oDlg ; 

INTERVAL 70 ACTION ( If( oBmp:nY < -oBmp:nWidth() + nFrameWidth*2,oBmp:nY := 0,; 

oBmp:nY -= nFrameWidth ), oBmp:Refresh( .f. ) ) 

ACTIVATE TIMER oTmr 

return nil

*/